#ifndef __GAME_CORE_H__
#define __GAME_CORE_H__

#define BOARD_WIDTH 16
#define BOARD_HEIGHT 16


enum game_state {
  Free_hand,       /* Le joueur n'a aucune pice en main. Il peut aller en */
                   /* choisir une  positionner dans le pool  droite ou   */
                   /* aller en chercher une sur le tableau pour la retirer */
		   /* afin qu'elle retourne dans le pool des pices        */
		   /* disponibles  gauche.                                */
  Handling_piece   /* Le joueur tien tient une pice. Il doit la jeter pour */
                   /* la remettre dans le pool des pices disponibles */
                   /* ou la positionner dans la zone de jeu  gaucbe. */
} ;


/* Dfinition des zones grossires o le curseur du joueur peut se trouver. */
enum area {
  Area_board,
  Area_Select_Shape_Square_1x1,
  Area_Select_Shape_Square_4x4,
  Area_Select_Shape_Long,
  Area_Select_Shape_Junction,
  Area_Select_Shape_Stair_1,
  Area_Select_Shape_Stair_2,
  Area_Select_Shape_Corner
} ;

/* Dfinition prcise des endroits o le curseur du joueur peut se trouver. */
struct location {
  enum area player_area ;
  /* Significatifs seulement dans le cas o player_area est Area_board.  */
  /* Sinon, conserve la dernire position que le joueur avait dans       */
  /* l'Area_board avant qu'il ne passe en position de slection de pice */
  /* dans la zone des pices disponibles.                                */
  short x_as_index ;
  short y_as_index ;
  /* Significatif seulement lorsque le joueur tient une pice. Dsigne    */
  /* le numro du bloc de la pice par lequel le joueur "tient" la pice. */
  unsigned short hot_spot ;
  /* Significatif seulement dans le cas o player_area */
  /* est Area_board et state est  Handling_piece.     */
  Piece handled_piece ;
} ;

struct game {
  struct location player_location ;
  enum game_state state ;
  /* Disposition courante des pices du joueur sur l'aire de jeu. */
  Piece board[BOARD_WIDTH][BOARD_HEIGHT] ;
  /* Map reprsentant le dessin  atteindre. */
  unsigned char aim[BOARD_WIDTH][BOARD_HEIGHT] ;
  short nb_remaining_cells ;
  unsigned short remaining_pieces[SHAPES_NUMBER] ;
} ;


struct aim_data {
  u16 bits[BOARD_HEIGHT] ;
  unsigned short pieces[SHAPES_NUMBER] ;
} ;

enum game_end {
  Goal_reached, Please_retry, I_give_up
} ;


struct game* start_game (struct aim_data*) ;
enum game_end game_main_loop (struct game*) ;
#endif
