#include <stdlib.h>
#include <gba.h>
#include <interrupt.h>
#include "it_handlers.h"
#include "shapes.h"
#include "wait_screen.h"
#include "game_core.h"
#include "ihm.h"
#include "levels_data.h"
#include "intro_gfx.h"
#include "abandon_gfx.h"
#include "goal_gfx.h"
#include "lev_sel.h"
#include "persistent.h"
#include "wav_bye_bye.h"
#include "wav_wow.h"




int main ()
{
  struct game* game ;
  int current_level = -1 ;

  init_sound_handler () ;
  /* Introduction. */
  show_at_toplevel (INTRO_PALETTE_SIZE,
		    intro_palette,
		    INTRO_NB_TILES,
		    intro_tiles,
		    INTRO_MAP_WIDTH,
		    INTRO_MAP_HEIGHT,
		    intro_map) ;
  srand (REG_VCOUNT) ;
  /* Test de la rinitialisation des tableaux effectus. */
  /* Combinaison: Left + Right + A. */
  if (! (REG_P1 & (BUTTON_LEFT | BUTTON_RIGHT | BUTTON_A)))
    reset_progresion () ;
  load_progression () ;
  init_persistent_sprites_data () ;
  for (;;) {
    current_level = setup_directory_selection (current_level) ;
    setup_board_graphics () ;
    game = start_game ((struct aim_data*) &levels[current_level]) ;
    initial_board_refresh (game) ;
    switch (game_main_loop (game)) {
    case Goal_reached:
      play_sound (g_wav_wow) ;
      show_at_toplevel (GOAL_PALETTE_SIZE,
			goal_palette,
			GOAL_NB_TILES,
			goal_tiles,
			GOAL_MAP_WIDTH,
			GOAL_MAP_HEIGHT,
			goal_map) ;
      progression[current_level] = 1 ;
      save_progression () ;
      current_level = (current_level + 1) % NB_AVAILABLE_LEVELS ;
      break ;
    case Please_retry:
      play_sound (g_wav_bye_bye) ;
      show_at_toplevel (ABANDON_PALETTE_SIZE,
			abandon_palette,
			ABANDON_NB_TILES,
			abandon_tiles,
			ABANDON_MAP_WIDTH,
			ABANDON_MAP_HEIGHT,
			abandon_map) ;
      break ;
    case I_give_up:
      play_sound (g_wav_bye_bye) ;
      show_at_toplevel (ABANDON_PALETTE_SIZE,
			abandon_palette,
			ABANDON_NB_TILES,
			abandon_tiles,
			ABANDON_MAP_WIDTH,
			ABANDON_MAP_HEIGHT,
			abandon_map) ;
      break ;
    }
  }
}
