#include <stdlib.h>
#include <gba.h>
#include "levels_data.h"
#include "persistent.h"


u8 progression[NB_AVAILABLE_LEVELS] ;


/* Pour viter de saturer la pile. */
static struct save tmp ;


void save_progression ()
{
  u8 *save_memory = (u8*) 0x0E000000 ;
  int i ;

  tmp.magic_tag = MAGICNUMBER ;
  for (i = 0; i < NB_AVAILABLE_LEVELS; i++) tmp.progress[i] = progression[i] ;
 
  /* Et enfin on crit rellement dans la SRAM. */
  for (i = 0; i < sizeof (struct save); i++)
    save_memory[i] = ((char*) &tmp)[i] ;
}



void load_progression ()
{
  u8 *save_memory = (u8*) 0x0E000000 ;
  int i ;
 
  for (i = 0; i < sizeof (struct save); i++)
    ((char*) &tmp)[i] = save_memory[i] ;

  if (tmp.magic_tag != MAGICNUMBER) {
    for (i = 0; i < NB_AVAILABLE_LEVELS; i++) progression[i] = 0 ;
  }
  else {
    for (i = 0; i < NB_AVAILABLE_LEVELS; i++)
      progression[i] = tmp.progress[i] ;
  }
}


void reset_progresion ()
{
  int i ;

  for (i = 0; i < NB_AVAILABLE_LEVELS; i++) progression[i] = 0 ;
  save_progression () ; 
}
