#include "shapes.h"

/* cc_Shape_Square_1x1 0
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |   .      |
   5 |          |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Square_1x1_0[] =
{ { 0, 0 } };
static const struct chain_code cc_Shape_Square_1x1_0 = {
  1,                                /* length */
  deltas_cc_Shape_Square_1x1_0      /* codes */
};


/* cc_Shape_Square_4x4 0
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |   ..     |
   5 |   ..     |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Square_4x4_0[] =
  { { 1, 0 }, { 0, 1 }, { -1, 0 }, { 0, -1 }  };
static const struct chain_code cc_Shape_Square_4x4_0 = {
  4,                              /* length */
  deltas_cc_Shape_Square_4x4_0    /* codes */
};

/* cc_Shape_Long 0
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |   .      |
   5 |   .      |
   6 |   .      |
   7 |   .      |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Long_0[] =
  { { 0, 1 }, { 0, 1 }, { 0, 1 }, { 0, -3 }  };
static const struct chain_code cc_Shape_Long_0 = {
  4,                         /* length */
  deltas_cc_Shape_Long_0     /* codes */
};

/* cc_Shape_Long 90
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |....      |
   5 |          |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Long_90[] =
  { { -1, 0 }, { -1, 0 }, { -1, 0 }, { 3, 0 }  };
static const struct chain_code cc_Shape_Long_90 = {
  4,                         /* length */
  deltas_cc_Shape_Long_90    /* codes */
};

/* cc_Shape_Junction 0
   0 |          |
   1 |          |
   2 |          |
   3 |    .     |
   4 |   ...    |
   5 |          |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Junction_0[] =
  { { 1, 0 }, { 0, -1 }, { 1, 1 }, { -2, 0 }  };
static const struct chain_code cc_Shape_Junction_0 = {
  4,                         /* length */
  deltas_cc_Shape_Junction_0    /* codes */
};

/* cc_Shape_Junction 90
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |   .      |
   5 |   ..     |
   6 |   .      |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Junction_90[] =
  { { 0, 1 }, { 1, 0 }, { -1, 1 }, { 0, -2 }  };
static const struct chain_code cc_Shape_Junction_90 = {
  4,                             /* length */
  deltas_cc_Shape_Junction_90    /* codes */
};

/* cc_Shape_Junction 180
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 | ...      |
   5 |  .       |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Junction_180[] =
  { { -1, 0 }, { 0, 1 }, { -1, -1 }, { 2, 0 }  };
static const struct chain_code cc_Shape_Junction_180 = {
  4,                              /* length */
  deltas_cc_Shape_Junction_180    /* codes */
};

/* cc_Shape_Junction 270
   0 |          |
   1 |          |
   2 |   .      |
   3 |  ..      |
   4 |   .      |
   5 |          |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Junction_270[] =
  { { 0, -1 }, { -1, 0 }, { 1, -1 }, { 0, 2 }  };
static const struct chain_code cc_Shape_Junction_270 = {
  4,                              /* length */
  deltas_cc_Shape_Junction_270    /* codes */
};

/* cc_Shape_Stair_1 0
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |   ..     |
   5 |    ..    |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Stair_1_0[] =
  { { 1, 0 }, { 0, 1 }, { 1, 0 }, { -2, -1 }  };
static const struct chain_code cc_Shape_Stair_1_0 = {
  4,                           /* length */
  deltas_cc_Shape_Stair_1_0    /* codes */
};

/* cc_Shape_Stair_1 90
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |   .      |
   5 |  ..      |
   6 |  .       |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Stair_1_90[] =
  { { 0, 1 }, { -1, 0 }, { 0, 1 }, { 1, -2 }  };
static const struct chain_code cc_Shape_Stair_1_90 = {
  4,                            /* length */
  deltas_cc_Shape_Stair_1_90    /* codes */
};

/* cc_Shape_Stair_2 0
   0 |          |
   1 |          |
   2 |          |
   3 |    ..    |
   4 |   ..     |
   5 |          |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Stair_2_0[] =
  { { 1, 0 }, { 0, -1 }, { 1, 0 }, { -2, 1 }  };
static const struct chain_code cc_Shape_Stair_2_0 = {
  4,                           /* length */
  deltas_cc_Shape_Stair_2_0    /* codes */
};

/* cc_Shape_Stair_2 90
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |   .      |
   5 |   ..     |
   6 |    .     |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Stair_2_90[] =
  { { 0, 1 }, { 1, 0 }, { 0, 1 }, { -1, -2 } };
static const struct chain_code cc_Shape_Stair_2_90 = {
  4,                            /* length */
  deltas_cc_Shape_Stair_2_90    /* codes */
};

/* ** cc_Shape_Corner 0
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |   .      |
   5 |   ..     |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Corner_0[] =
  { { 0, 1 }, { 1, 0 }, { -1, -1 } };
static const struct chain_code cc_Shape_Corner_0 = {
  3,                            /* length */
  deltas_cc_Shape_Corner_0      /* codes */
};

/* ** cc_Shape_Corner 90
   0 |          |
   1 |          |
   2 |          |
   3 |          |
   4 |  ..      |
   5 |  .       |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Corner_90[] =
  { { -1, 0 }, { 0, 1 }, { 1, -1 } };
static const struct chain_code cc_Shape_Corner_90 = {
  3,                           /* length */
  deltas_cc_Shape_Corner_90    /* codes */
};

/* ** cc_Shape_Corner 180
   0 |          |
   1 |          |
   2 |          |
   3 |  ..      |
   4 |   .      |
   5 |          |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Corner_180[] =
  { { 0, -1 }, { -1, 0 }, { 1, 1 } };
static const struct chain_code cc_Shape_Corner_180 = {
  3,                           /* length */
  deltas_cc_Shape_Corner_180    /* codes */
};
/* ** cc_Shape_Corner 270
   0 |          |
   1 |          |
   2 |          |
   3 |    .     |
   4 |   ..     |
   5 |          |
   6 |          |
   7 |          |
   8 |          |
   9 |          |
*/
static struct deltas deltas_cc_Shape_Corner_270[] =
  { { 1, 0 }, { 0, -1 }, { -1, 1 } };
static const struct chain_code cc_Shape_Corner_270 = {
  3,                            /* length */
  deltas_cc_Shape_Corner_270    /* codes */
};




const struct chain_code* rotated_shapes_ccodes[SHAPES_NUMBER][4] = {
  { &cc_Shape_Square_1x1_0, &cc_Shape_Square_1x1_0,
    &cc_Shape_Square_1x1_0, &cc_Shape_Square_1x1_0 },
  { &cc_Shape_Square_4x4_0, &cc_Shape_Square_4x4_0,
    &cc_Shape_Square_4x4_0, &cc_Shape_Square_4x4_0 },
  { &cc_Shape_Long_0, &cc_Shape_Long_90,
    &cc_Shape_Long_0, &cc_Shape_Long_90 },
  { &cc_Shape_Junction_0, &cc_Shape_Junction_90,
    &cc_Shape_Junction_180, &cc_Shape_Junction_270 },
  { &cc_Shape_Stair_1_0, &cc_Shape_Stair_1_90,
    &cc_Shape_Stair_1_0, &cc_Shape_Stair_1_90 },
  { &cc_Shape_Stair_2_0, &cc_Shape_Stair_2_90,
    &cc_Shape_Stair_2_0, &cc_Shape_Stair_2_90 },
  { &cc_Shape_Corner_0, &cc_Shape_Corner_90,
    &cc_Shape_Corner_180, &cc_Shape_Corner_270 }
};

