#include <gba.h>
#include "shapes.h"




static const u8 map_Shape_Square_1x1_0[1]
  __attribute__ ((section (".rodata"))) = {
  0x00
};

static const u8 map_Shape_Square_4x4_0[4]
  __attribute__ ((section (".rodata"))) = {
  0x02, 0x03,
  0x05, 0x04
};

static const u8 map_Shape_Long_0[4]
  __attribute__ ((section (".rodata"))) = {
  0x06,
  0x07,
  0x07,
  0x08
};

static const u8 map_Shape_Long_90[4]
  __attribute__ ((section (".rodata"))) = {
  0x0b, 0x0a, 0x0a, 0x09
};

static const u8 map_Shape_Junction_0[4]
  __attribute__ ((section (".rodata"))) = {
  0x09, 0x0c, 0x06, 0x0b
};

static const u8 map_Shape_Junction_90[4]
  __attribute__ ((section (".rodata"))) = {
  0x06, 0x0d, 0x0b, 0x08
};

static const u8 map_Shape_Junction_180[4]
  __attribute__ ((section (".rodata"))) = {
    0x0b, 0x0e, 0x08, 0x09
};

static const u8 map_Shape_Junction_270[4]
  __attribute__ ((section (".rodata"))) = {
  0x08, 0x0f, 0x09, 0x06  
};

static const u8 map_Shape_Stair_1_0[4]
  __attribute__ ((section (".rodata"))) = {
  0x09, 0x10, 0x11,0x0b
};

static const u8 map_Shape_Stair_1_90[4]
  __attribute__ ((section (".rodata"))) = {
  0x06, 0x13, 0x12, 0x08
};

static const u8 map_Shape_Stair_2_0[4]
  __attribute__ ((section (".rodata"))) = {
  0x09, 0x13, 0x12, 0x0b
};

static const u8 map_Shape_Stair_2_90[4]
   __attribute__ ((section (".rodata"))) = {
  0x06, 0x11, 0x10, 0x08
};

static const u8 map_Shape_Corner_0[3]
   __attribute__ ((section (".rodata"))) = {
     0x0006, 0x0011,0x000b
};

static const u8 map_Shape_Corner_90[3]
   __attribute__ ((section (".rodata"))) = {
     0x000b, 0x0012, 0x0008
};

static const u8 map_Shape_Corner_180[3]
   __attribute__ ((section (".rodata"))) = {
     0x0008, 0x0010, 0x0009
};

static const u8 map_Shape_Corner_270[3]
   __attribute__ ((section (".rodata"))) = {
     0x0009,0x0013,0x0006
};

const u8* rotated_shapes_maps[SHAPES_NUMBER][4] = {
  { map_Shape_Square_1x1_0, map_Shape_Square_1x1_0,
    map_Shape_Square_1x1_0, map_Shape_Square_1x1_0 },
  { map_Shape_Square_4x4_0, map_Shape_Square_4x4_0,
    map_Shape_Square_4x4_0, map_Shape_Square_4x4_0 },
  { map_Shape_Long_0, map_Shape_Long_90,
    map_Shape_Long_0,  map_Shape_Long_90 },
  { map_Shape_Junction_0, map_Shape_Junction_90,
    map_Shape_Junction_180, map_Shape_Junction_270 },
  { map_Shape_Stair_1_0, map_Shape_Stair_1_90,
    map_Shape_Stair_1_0, map_Shape_Stair_1_90 },
  { map_Shape_Stair_2_0, map_Shape_Stair_2_90,
    map_Shape_Stair_2_0, map_Shape_Stair_2_90 },
  { map_Shape_Corner_0, map_Shape_Corner_90,
    map_Shape_Corner_180, map_Shape_Corner_270 }
};
